"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// @TODO: implement all this parts of the token: https://developer.8x8.com/jaas/docs/api-keys-jwt
const dotenv = __importStar(require("dotenv"));
const envalid_1 = __importDefault(require("envalid"));
const fs_1 = __importDefault(require("fs"));
const logger_1 = __importDefault(require("./logger"));
const token_generator_1 = __importDefault(require("./token_generator"));
const context_1 = require("./util/context");
dotenv.config();
const env = envalid_1.default.cleanEnv(process.env, {
    ASAP_EXPIRES_IN: envalid_1.default.str({ default: '' }),
    ASAP_JWT_ISS: envalid_1.default.str({ default: 'jitsi-token-generator' }),
    ASAP_JWT_AUD: envalid_1.default.str({ default: 'jitsi' }),
    ASAP_SIGNING_KEY_FILE: envalid_1.default.str(),
    ASAP_JWT_KID: envalid_1.default.str(),
    ASAP_TYPE: envalid_1.default.str({ default: '' }),
    ASAP_JWT_SUB: envalid_1.default.str({ default: undefined }),
    ASAP_ROOM: envalid_1.default.str({ default: '' }),
    ASAP_PAYLOAD: envalid_1.default.json({ default: undefined }),
    ASAP_SCD: envalid_1.default.str({ default: undefined }) // cluster scope domain
});
const jwtSigningKey = fs_1.default.readFileSync(env.ASAP_SIGNING_KEY_FILE);
const tokenGenerator = new token_generator_1.default({
    signingKey: jwtSigningKey,
    asapJwtIss: env.ASAP_JWT_ISS,
    asapJwtAud: env.ASAP_JWT_AUD,
    asapJwtKid: env.ASAP_JWT_KID,
    asapJwtSub: env.ASAP_JWT_SUB
});
const ctx = new context_1.Context(logger_1.default, 0, '');
let token = '';
let asapType = 'server';
if (env.ASAP_TYPE) {
    asapType = env.ASAP_TYPE;
}
const payload = env.ASAP_PAYLOAD ? env.ASAP_PAYLOAD : {};
switch (asapType) {
    case 'server': {
        if (env.ASAP_SCD) {
            payload.scd = env.ASAP_SCD;
        }
        const signOptions = {};
        if (env.ASAP_EXPIRES_IN) {
            signOptions.expiresIn = env.ASAP_EXPIRES_IN;
        }
        token = tokenGenerator.serverToken(ctx, payload, signOptions);
        break;
    }
    case 'client':
        token = tokenGenerator.clientToken(ctx, {
            ...payload,
            room: env.ASAP_ROOM ? env.ASAP_ROOM : '*'
        }, { expiresIn: env.ASAP_EXPIRES_IN ? env.ASAP_EXPIRES_IN : '1 day' });
        break;
    case 'component':
        token = tokenGenerator.clientToken(ctx, { room: env.ASAP_ROOM ? env.ASAP_ROOM : '*' }, {
            audience: 'jitsi-component',
            expiresIn: '1 day',
            subject: '*'
        });
        break;
    default:
        token = 'wtfbbq';
        break;
}
console.log(token);
